您的位置:首页 > 其它

HDU 2955 Robberies

2013-08-10 20:34 323 查看
Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before
retiring to a comfortable job at a university.



For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

 

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line
j gives an integer Mj and a floating point number Pj . 

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

 

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints

0 < T <= 100

0.0 <= P <= 1.0

0 < N <= 100

0 < Mj <= 100

0.0 <= Pj <= 1.0

A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

 

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

 

Sample Output

2
4
6

题意:给定一个概率p和n家银行。以下n行为小偷在每家银行能偷到的钱和被抓概率。要求出小偷在被抓概率小于p的情况下,偷到最多的钱数。

思路:01背包。但是这题中。概率是double型数。不能用概率来做背包。。所以转一下思路,用偷到的钱数做背包。

我们知道小偷在不被抓的情况下才能偷到更多的钱。所以转换成。小偷偷到钱数不被抓的概率。最后在进行一次遍历。从最大的钱数开始。如果不被抓的概率> 1- p。那么这个钱数将是能偷到的最多的钱

#include <stdio.h>
#include <string.h>

int t;
double p;
int n;
double pj[105];
int mj[105];
double dp[10005];
int sum;

double max(double a, double b) {
return a > b ? a : b;
}
int main() {
scanf("%d", &t);
while (t --) {
dp[0] = 1;
sum = 0;
scanf("%lf%d", &p, &n);
p = 1 - p;
for (int i = 0; i < n; i ++) {
scanf("%d%lf", &mj[i], &pj[i]);
sum += mj[i];
pj[i] = 1 - pj[i];
}
for (int i = 1; i <= sum; i ++)
dp[i] = -1;
for (int i = 0; i < n; i ++)
for (int j = sum; j >= mj[i]; j --) {
if (dp[j - mj[i]] != -1)
{
dp[j] = max(dp[j - mj[i]] * pj[i], dp[j]);
}
}
for (int i = sum; i >= 0; i --) {
if (dp[i] > p) {
printf("%d\n", i);
break;
}
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: